import { NgxLoggerLevel } from './../types/logger-level.enum';
import { INGXLoggerConfigEngine } from './iconfig-engine';
import { INGXLoggerConfig } from './iconfig';
export declare class NGXLoggerConfigEngine implements INGXLoggerConfigEngine {
    private config;
    constructor(config: INGXLoggerConfig);
    /** Get a readonly access to the level configured for the NGXLogger */
    get level(): NgxLoggerLevel;
    /** Get a readonly access to the serverLogLevel configured for the NGXLogger */
    get serverLogLevel(): NgxLoggerLevel;
    updateConfig(config: INGXLoggerConfig): void;
    /** Update the config partially
     * This is useful if you want to update only one parameter of the config
     */
    partialUpdateConfig(partialConfig: Partial<INGXLoggerConfig>): void;
    getConfig(): INGXLoggerConfig;
    private _clone;
}
//# sourceMappingURL=config-engine.d.ts.map